using System;
using System.Runtime.InteropServices;
using System.Threading;

namespace Utils
{
    /// <summary>
    /// мع
    /// ṩʱûָʱδʱTimeout¼
    /// </summary>
    public class IdleUtil
    {
        #region Public

        /// <summary>
        /// öʱΪʱ
        /// </summary>
        /// <param name="dueTime">ʱδ¼룩</param>
        public void Reset(int dueTime)
        {
            Start(dueTime);
        }

        /// <summary>
        /// öʱ
        /// </summary>
        public void Reset()
        {
            Start(this.DueTime);
        }

        /// <summary>
        /// ʼʱ
        /// </summary>
        /// <param name="dueTime">ʱδ¼룩</param>
        public void Start(int dueTime)
        {
            DueTime = dueTime;
            if (!IsRunning)
            {
                IsRunning = true;
                MonitorThread = new Thread(Moniter) { IsBackground = true };
                MonitorThread.Start();
            }
            Timer.Change(dueTime, Timeout.Infinite);
        }

        /// <summary>
        /// ֹͣʱ
        /// </summary>
        public void Stop()
        {
            IsRunning = false;
            Timer.Change(Timeout.Infinite, Timeout.Infinite);
        }

        #endregion Public

        #region Event

        /// <summary>
        /// ָ¼δ¼
        /// </summary>
        public event EventHandler TimeoutEvent;

        #endregion Event

        #region Ctor

        public IdleUtil()
        {
            Timer = new Timer(OnTimeout);
        }

        #endregion Ctor

        #region Private

        /// <summary>
        /// ʱ
        /// </summary>
        private readonly Timer  Timer;

        /// <summary>
        /// ûҪʱʱ
        /// </summary>
        private          int    DueTime;

        /// <summary>
        /// ߳Ƿ
        /// </summary>
        private          bool   IsRunning;

        /// <summary>
        /// ߳
        /// </summary>
        private          Thread MonitorThread;
        /// <summary>
        /// ̷߳
        /// </summary>
        private void Moniter()
        {
            while (IsRunning)
            {
                if (GetLastInputTime() == 0)
                    Reset();
                Thread.Sleep(1000);
            }
        }

        #endregion Private

        #region Trigger

        private void OnTimeout(object _)
        {
            if (TimeoutEvent != null)
                TimeoutEvent(this, EventArgs.Empty);
            // ֻһ
            Timer.Change(Timeout.Infinite, Timeout.Infinite);
        }

        #endregion Trigger

        #region WindowsAPI

        [DllImport("user32.dll")]
        private static extern bool GetLastInputInfo(ref LASTINPUTINFO plii);

        /// <summary>
        /// ȡûһʱ
        /// </summary>
        /// <returns>һʱ</returns>
        private static uint GetLastInputTime()
        {
            uint idleTime = 0;
            LASTINPUTINFO lastInputInfo = new LASTINPUTINFO();
            lastInputInfo.cbSize = (uint)Marshal.SizeOf(lastInputInfo);
            lastInputInfo.dwTime = 0;

            uint envTicks = (uint)Environment.TickCount;

            if (GetLastInputInfo(ref lastInputInfo))
            {
                uint lastInputTick = lastInputInfo.dwTime;

                idleTime = envTicks - lastInputTick;
            }

            return ((idleTime > 0) ? (idleTime / 1000) : 0);
        }

        [StructLayout(LayoutKind.Sequential)]
        private struct LASTINPUTINFO
        {
            public static readonly int SizeOf = Marshal.SizeOf(typeof(LASTINPUTINFO));

            [MarshalAs(UnmanagedType.U4)]
            public UInt32 cbSize;

            [MarshalAs(UnmanagedType.U4)]
            public UInt32 dwTime;
        }

        #endregion WindowsAPI
    }
}